----------------------------------------------------------------
-- Multiplication of OEF polynomials mod f (OEF_LSE_mult.adb)
--
-- Least Significant Element(LSE)-First multiplier
-- for Optimal Extension Fields (OEF) 
--
----------------------------------------------------------------
with Gnat.Io; use Gnat.Io;
with finite_fields_ch5; use finite_fields_ch5;
with polynomials_ch5; use polynomials_ch5;

procedure OEF_LSE_mult is 
   A,B: Polynomial_m1;
   D: Polynomial_m1;
   c: Integer;

begin
loop

   for i in 0 .. m-1 loop Put("A(");Put(i);Put(") = "); Get(A(i)); end loop; New_Line;
   for i in 0 .. m-1 loop Put("B(");Put(i);Put(") = "); Get(B(i)); end loop; New_Line;
   Put("C = "); Get(c); New_Line;
   
   for i in 0 .. m-1 loop D(i) := 0; end loop;
   
   for i in 0 .. m-1 loop
      D := addition_mod_f_poly(product(A,B(i)),D);
      A := mult_x_OEF(A,c);
   end loop;  
    
Put("D = "); for i in 0 .. m-1 loop Put(D(i)); Put(","); end loop; New_Line; New_Line;

end loop;
end OEF_LSE_mult;

