----------------------------------------------------------------------
-- Finite Field Chapter 5 package (finite_field_ch5.ads)
-- 
-- Defines useful funtions for finite field operations
-- of Chapter 5 examples
---------------------------------------------------------------------
package finite_fields_ch5 is
   subtype Bit is Natural range 0 .. 1;
   type bit_vector is array (natural range <>) of bit;

   function mod_m_addition(x, y, m, k: natural) return natural;
   function mod_m_subtraction(x, y, m, k: natural) return natural;
   function dar_mod_multiplication(x, y, m, k: natural) return natural;
   function quotient(s: in integer; y: in natural) return integer;
   function nr_reducer(x: in integer; p: in natural; n,k: natural) return integer;

end finite_fields_ch5;

