----------------------------------------------------------------------
-- Polynomials Chapter 5 package (polynomials_ch5.ads)
-- 
-- Defines several funtions for Polynomials operations
-- of Chapter 5 examples
---------------------------------------------------------------------
with finite_fields_ch5; use finite_fields_ch5;
package polynomials_ch5 is

   m: constant natural := 8;
   p: constant natural := 17;
--   m: constant natural := 17;
--   p: constant natural := 239;
   
   subtype Natural_Mod_P is Natural range 0 .. p-1;
   type Polynomial_m1 is array(0 .. m-1) of Natural_Mod_P;
   type Polynomial_m2 is array(0 .. 2*m-2) of Natural_Mod_P;
   type Polynomial_matrix_m1m2 is array (0 .. m-1, 0 .. m-2) of Natural_Mod_P;
   
   function Subtract(A, B: Polynomial_m1) return Polynomial_m1;
   function poly_mult_zp(A, B: Polynomial_m1) return Polynomial_m2;
--   function poly_mult_zp(A, B: Polynomial_m1; p,m: natural) return Polynomial_m2;
   function reduction_matrix_R_zp(F: Polynomial_m1) return Polynomial_matrix_m1m2;
--   function reduction_matrix_R_zp(F: Polynomial_m1; p,m: natural) return Polynomial_matrix_m1m2;
   function multiply_by_x_zp(s, f: polynomial_m1) return polynomial_m1; 
--   function multiply_by_x_zp(s, f: polynomial_m1;  p,m: natural) return polynomial_m1; 
   function Product(a: Polynomial_m1; b: Natural_Mod_P) return Polynomial_m1;
   function addition_mod_f_poly(a, b: Polynomial_m1) return Polynomial_m1;
   function LSEfirst(a, b, f: Polynomial_m1) return Polynomial_m1;
   function mult_x_OEF(s: polynomial_m1; c: integer) return polynomial_m1;
   function OEF_LSE_mult(a,b: polynomial_m1; c: integer) return polynomial_m1;
  
end polynomials_ch5;

